/**
 * generated by Xtext 2.12.0
 */
package com.javadude.simpleobjectdsl.generator;

import com.google.common.base.Objects;
import com.google.common.collect.Iterators;
import com.javadude.simpleobjectdsl.simpleObjectDsl.BasicField;
import com.javadude.simpleobjectdsl.simpleObjectDsl.ClassType;
import com.javadude.simpleobjectdsl.simpleObjectDsl.EnumType;
import com.javadude.simpleobjectdsl.simpleObjectDsl.EnumValue;
import com.javadude.simpleobjectdsl.simpleObjectDsl.FieldDecl;
import com.javadude.simpleobjectdsl.simpleObjectDsl.ListField;
import com.javadude.simpleobjectdsl.simpleObjectDsl.Model;
import com.javadude.simpleobjectdsl.simpleObjectDsl.PrimitiveField;
import java.util.Arrays;
import java.util.function.Consumer;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.eclipse.xtext.xbase.lib.StringExtensions;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class SimpleObjectDslGenerator extends AbstractGenerator {
  private IFileSystemAccess2 fsa;
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    this.fsa = fsa;
    final Procedure1<Model> _function = (Model it) -> {
      final Consumer<ClassType> _function_1 = (ClassType it_1) -> {
        this.genClass(it_1);
      };
      it.getClasses().forEach(_function_1);
    };
    IteratorExtensions.<Model>forEach(Iterators.<Model>filter(resource.getAllContents(), Model.class), _function);
    final Procedure1<Model> _function_1 = (Model it) -> {
      final Consumer<EnumType> _function_2 = (EnumType it_1) -> {
        this.genEnum(it_1);
      };
      it.getEnums().forEach(_function_2);
    };
    IteratorExtensions.<Model>forEach(Iterators.<Model>filter(resource.getAllContents(), Model.class), _function_1);
  }
  
  public Model modelOf(final EObject object) {
    EObject _eContainer = object.eContainer();
    return ((Model) _eContainer);
  }
  
  public String path(final Model model) {
    return model.getPkg().replace(".", "/");
  }
  
  public void genClass(final ClassType classType) {
    StringConcatenation _builder = new StringConcatenation();
    String _path = this.path(this.modelOf(classType));
    _builder.append(_path);
    _builder.append("/");
    String _name = classType.getName();
    _builder.append(_name);
    _builder.append(".java");
    StringConcatenation _builder_1 = new StringConcatenation();
    _builder_1.append("package ");
    String _pkg = this.modelOf(classType).getPkg();
    _builder_1.append(_pkg);
    _builder_1.append(";");
    _builder_1.newLineIfNotEmpty();
    _builder_1.newLine();
    _builder_1.append("public class ");
    String _name_1 = classType.getName();
    _builder_1.append(_name_1);
    _builder_1.append(" {");
    _builder_1.newLineIfNotEmpty();
    {
      EList<FieldDecl> _fields = classType.getFields();
      for(final FieldDecl field : _fields) {
        _builder_1.append("\t");
        String _genField = this.genField(field);
        _builder_1.append(_genField, "\t");
        _builder_1.newLineIfNotEmpty();
      }
    }
    _builder_1.append("}");
    _builder_1.newLine();
    this.fsa.generateFile(_builder.toString(), _builder_1);
  }
  
  protected String _genField(final BasicField field) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("private ");
    String _name = field.getType().getName();
    _builder.append(_name);
    _builder.append(" ");
    String _name_1 = field.getName();
    _builder.append(_name_1);
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("public ");
    String _name_2 = field.getType().getName();
    _builder.append(_name_2);
    _builder.append(" get");
    String _firstUpper = StringExtensions.toFirstUpper(field.getName());
    _builder.append(_firstUpper);
    _builder.append("() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this.");
    String _name_3 = field.getName();
    _builder.append(_name_3, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    _builder.append("public ");
    EObject _eContainer = field.eContainer();
    String _name_4 = ((ClassType) _eContainer).getName();
    _builder.append(_name_4);
    _builder.append(" set");
    String _firstUpper_1 = StringExtensions.toFirstUpper(field.getName());
    _builder.append(_firstUpper_1);
    _builder.append("(");
    String _name_5 = field.getType().getName();
    _builder.append(_name_5);
    _builder.append(" ");
    String _name_6 = field.getName();
    _builder.append(_name_6);
    _builder.append(") {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("this.");
    String _name_7 = field.getName();
    _builder.append(_name_7, "\t");
    _builder.append(" = ");
    String _name_8 = field.getName();
    _builder.append(_name_8, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  public String getOrIs(final String type) {
    String _xifexpression = null;
    boolean _equals = Objects.equal(type, "boolean");
    if (_equals) {
      _xifexpression = "is";
    } else {
      _xifexpression = "get";
    }
    return _xifexpression;
  }
  
  protected String _genField(final PrimitiveField field) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("private ");
    String _type = field.getType();
    _builder.append(_type);
    _builder.append(" ");
    String _name = field.getName();
    _builder.append(_name);
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("public ");
    String _type_1 = field.getType();
    _builder.append(_type_1);
    _builder.append(" ");
    String _orIs = this.getOrIs(field.getType());
    _builder.append(_orIs);
    String _firstUpper = StringExtensions.toFirstUpper(field.getName());
    _builder.append(_firstUpper);
    _builder.append("() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this.");
    String _name_1 = field.getName();
    _builder.append(_name_1, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    _builder.append("public ");
    EObject _eContainer = field.eContainer();
    String _name_2 = ((ClassType) _eContainer).getName();
    _builder.append(_name_2);
    _builder.append(" set");
    String _firstUpper_1 = StringExtensions.toFirstUpper(field.getName());
    _builder.append(_firstUpper_1);
    _builder.append("(");
    String _type_2 = field.getType();
    _builder.append(_type_2);
    _builder.append(" ");
    String _name_3 = field.getName();
    _builder.append(_name_3);
    _builder.append(") {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("this.");
    String _name_4 = field.getName();
    _builder.append(_name_4, "\t");
    _builder.append(" = ");
    String _name_5 = field.getName();
    _builder.append(_name_5, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  protected String _genField(final ListField field) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("private final java.util.List<");
    String _name = field.getType().getName();
    _builder.append(_name);
    _builder.append("> ");
    String _name_1 = field.getName();
    _builder.append(_name_1);
    _builder.append(" = new java.util.ArrayList<>();");
    _builder.newLineIfNotEmpty();
    _builder.append("private final java.util.List<");
    String _name_2 = field.getType().getName();
    _builder.append(_name_2);
    _builder.append("> unmodifiable");
    String _firstUpper = StringExtensions.toFirstUpper(field.getName());
    _builder.append(_firstUpper);
    _builder.append(" = java.util.Collections.unmodifiableList(");
    String _name_3 = field.getName();
    _builder.append(_name_3);
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("public java.util.List<");
    String _name_4 = field.getType().getName();
    _builder.append(_name_4);
    _builder.append("> get");
    String _firstUpper_1 = StringExtensions.toFirstUpper(field.getName());
    _builder.append(_firstUpper_1);
    _builder.append("() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return unmodifiable");
    String _firstUpper_2 = StringExtensions.toFirstUpper(field.getName());
    _builder.append(_firstUpper_2, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    _builder.append("public ");
    EObject _eContainer = field.eContainer();
    String _name_5 = ((ClassType) _eContainer).getName();
    _builder.append(_name_5);
    _builder.append(" add");
    String _firstUpper_3 = StringExtensions.toFirstUpper(field.getSingular());
    _builder.append(_firstUpper_3);
    _builder.append("(");
    String _name_6 = field.getType().getName();
    _builder.append(_name_6);
    _builder.append(" item) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("this.");
    String _name_7 = field.getName();
    _builder.append(_name_7, "\t");
    _builder.append(".add(item);");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.append("public ");
    EObject _eContainer_1 = field.eContainer();
    String _name_8 = ((ClassType) _eContainer_1).getName();
    _builder.append(_name_8);
    _builder.append(" remove");
    String _firstUpper_4 = StringExtensions.toFirstUpper(field.getSingular());
    _builder.append(_firstUpper_4);
    _builder.append("(");
    String _name_9 = field.getType().getName();
    _builder.append(_name_9);
    _builder.append(" item) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("this.");
    String _name_10 = field.getName();
    _builder.append(_name_10, "\t");
    _builder.append(".remove(item);");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  public void genEnum(final EnumType enumType) {
    StringConcatenation _builder = new StringConcatenation();
    String _path = this.path(this.modelOf(enumType));
    _builder.append(_path);
    _builder.append("/");
    String _name = enumType.getName();
    _builder.append(_name);
    _builder.append(".java");
    StringConcatenation _builder_1 = new StringConcatenation();
    _builder_1.append("package ");
    String _pkg = this.modelOf(enumType).getPkg();
    _builder_1.append(_pkg);
    _builder_1.append(";");
    _builder_1.newLineIfNotEmpty();
    _builder_1.newLine();
    _builder_1.append("public enum ");
    String _name_1 = enumType.getName();
    _builder_1.append(_name_1);
    _builder_1.append(" {");
    _builder_1.newLineIfNotEmpty();
    {
      EList<EnumValue> _values = enumType.getValues();
      boolean _hasElements = false;
      for(final EnumValue value : _values) {
        if (!_hasElements) {
          _hasElements = true;
        } else {
          _builder_1.appendImmediate(",", "\t");
        }
        _builder_1.append("\t");
        String _name_2 = value.getName();
        _builder_1.append(_name_2, "\t");
        _builder_1.append("(");
        String _displayName = value.getDisplayName();
        _builder_1.append(_displayName, "\t");
        _builder_1.append(")");
        _builder_1.newLineIfNotEmpty();
      }
      if (_hasElements) {
        _builder_1.append(";", "\t");
      }
    }
    _builder_1.append("\t");
    _builder_1.append("private String displayName;");
    _builder_1.newLine();
    _builder_1.append("\t");
    _builder_1.append("private ");
    String _name_3 = enumType.getName();
    _builder_1.append(_name_3, "\t");
    _builder_1.append("(String displayName) {");
    _builder_1.newLineIfNotEmpty();
    _builder_1.append("\t\t");
    _builder_1.append("this.displayName = displayName;");
    _builder_1.newLine();
    _builder_1.append("\t");
    _builder_1.append("}");
    _builder_1.newLine();
    _builder_1.append("\t");
    _builder_1.append("public String getDisplayName() {");
    _builder_1.newLine();
    _builder_1.append("\t\t");
    _builder_1.append("return this.displayName;");
    _builder_1.newLine();
    _builder_1.append("\t");
    _builder_1.append("}");
    _builder_1.newLine();
    _builder_1.append("}");
    _builder_1.newLine();
    this.fsa.generateFile(_builder.toString(), _builder_1);
  }
  
  public String genField(final FieldDecl field) {
    if (field instanceof BasicField) {
      return _genField((BasicField)field);
    } else if (field instanceof ListField) {
      return _genField((ListField)field);
    } else if (field instanceof PrimitiveField) {
      return _genField((PrimitiveField)field);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(field).toString());
    }
  }
}
